        program calc_hess

        use constants 

        implicit none 
        
        integer :: ncart
        
        real*8, parameter :: del = 0.001d0
        real*8, allocatable, dimension(:) :: pp,pn,nn,np,p,n
        real*8, allocatable, dimension(:,:) :: nhess,hess
        integer :: dime,i,j,k,l       
        real*8 :: e 
        
        !Read new variables:
        open (100,file='../parameters.dat', status="old")
        read(100,*) ncart
        close(100)
 

        dime = ncart*(ncart-1)/2
        
        allocate(p(ncart))
        allocate(n(ncart))
        allocate(pp(dime))
        allocate(nn(dime))
        allocate(pn(dime))
        allocate(np(dime))
        allocate(hess(ncart,ncart))
        allocate(nhess(ncart,ncart))

        ! atom1(x,y,z)
        ! atom2(x,y,z) ecc...
        hess(:,:) = 0.d0
        nhess(:,:) = 0.d0

        open(unit=5, file='Energy.dat', status='old')

        ! eq value:
        read(5,*) e
        i=1
        l=1
        do while (i .le. ncart)
         read(5,*) p(l)
         l = l+1
         i = i+1
        end do
        l=1
        do while (i .le. 2*ncart)
         read(5,*) n(l)
         i = i+1
         l = l+1
        end do
        l=1
        do while (i .le. 2*ncart+ncart*(ncart-1)/2)
         read(5,*) pp(l)
         l = l+1
         i = i+1
        end do
        l=1
        do while (i .le. 2*ncart+ncart*(ncart-1))
         read(5,*) nn(l)
         l = l+1
         i = i+1
        end do
        l=1
        do while ( i .le. 2*ncart+(ncart*(ncart-1)/2)*3 )
         read(5,*) pn(l)
         l = l+1
         i = i+1
        end do 
        l=1
        do while ( i .le. 2*ncart+ncart*(ncart-1)*2 )
         read(5,*) np(l)
         l = l+1
         i = i+1
        end do

        close(5)
         
        ! Diagonal terms
        do i=1, ncart
         hess(i,i) = (p(i) + n(i) - 2.d0*e)/(del*1.88973d0)**2
        end do
    
        ! OFF-DIAGONAL terms
        k=1
        do i=1, ncart
         do j=(i+1), ncart
         hess(i,j) = (pp(k)+nn(k)-pn(k)-np(k))/(4.d0*(del*1.88973d0)**2)
         k = k+1
         end do
        end do
        
        do i = 1, ncart
         do j = 1, ncart
          if ( i.le.j ) nhess(i,j) = hess(i,j)
          if ( i.gt.j ) nhess(i,j) = hess(j,i)
         enddo
        enddo
        
        open(unit=5, file='Hessian.out', status='replace')
         do i=1, ncart
          write(5,*) nhess(i,:)
         end do
        close(5)


       end program calc_hess
