        program essiano

        use constants        

        implicit none        

        integer :: ncart, nat, mok
        real*8 :: mok2
        character(len=10) :: multcharge

        real*8, parameter :: step = 0.001d0
        real*8, allocatable, dimension(:) :: q, del
        real*8, allocatable, dimension(:,:) :: pp,pn,nn,np,p,n
        integer :: dime, y
        integer :: i,j,k,l
        real*8, allocatable :: geo(:,:)
        character(len=10) :: file_id
        character(len=50) :: file_name
        character(len=256) :: atoms
        character(len=256) :: dummy
        character(len=256) :: line1
        character(len=256) :: line2
        
        !Reading new variables:
        open (100,file='../parameters.dat', status="old")
        read(100,*) ncart
        read(100,*) mok
        read(100,*) mok
        read(100,*) nat
        read(100,*) mok2
        read(100,'(A)') multcharge
        close(100) 

        dime = ncart*(ncart-1)/2
        allocate(q(ncart))
        allocate(del(ncart))
        allocate(p(ncart,ncart))
        allocate(n(ncart,ncart))
        allocate(pp(ncart,dime))
        allocate(nn(ncart,dime))
        allocate(pn(ncart,dime))
        allocate(np(ncart,dime))
        allocate(geo(nat,3))

        open(unit=5, file='../atomi', status='old')
        read(5, '(A)') atoms
        close(5)

        open(unit=5, file='../data.dat', status='old')
        do i=1, 8
         read(5, '(A)') dummy
        end do
        read(5, '(A)') line1
        read(5, '(A)') line2
        close(5)

        open(unit=5, file='geo', status='old')
        do i=1, nat !Runs on the atoms: 
        read(5,*) (geo(i,j), j=1, 3)
        end do
        close(5)

        !3N positions vector
        k=1
        do i=1, nat
         do j=1, 3
         q(k) = geo(i,j)
         k = k+1
         end do
        end do
        !Displacement vec: 
        del(:) = step

        !Displacements definition:
        do i=1, ncart 
         do j=1, ncart
          if (j .ne. i) then
           p(j,i)=q(j)
          else if (j .eq. i) then
           p(j,i)=q(j) + del(i)
          end if
         end do
        end do

        do i=1, ncart 
         do j=1, ncart
          if (j .ne. i) then
           n(j,i)=q(j)
          else if (j .eq. i) then
           n(j,i)=q(j) - del(i)
          end if
         end do
        end do
        

        l=1
        do i=1, ncart 
         do j=(i+1), ncart 
          do k=1, ncart
          if (k .eq. j) then
           pp(k,l) = q(k) + del(j)
          else if (k .eq. i) then
           pp(k,l) = q(k) + del(i) 
          else
           pp(k,l) = q(k)
          end if
          end do
         l=l+1
         end do
        end do


        l=1
        do i=1, ncart 
         do j=(i+1), ncart
          do k=1, ncart
          if (k .eq. j) then
           nn(k,l) = q(k) - del(j)
          else if (k .eq. i) then
           nn(k,l) = q(k) - del(i)
          else
           nn(k,l) = q(k)
          end if
          end do
         l=l+1
         end do
        end do


        l=1
        do i=1, ncart 
         do j=(i+1), ncart 
          do k=1, ncart
          if (k .eq. j) then
           pn(k,l) = q(k) - del(j)
          else if (k .eq. i) then
           pn(k,l) = q(k) + del(i) 
          else
           pn(k,l) = q(k)
          end if
          end do
         l=l+1
         end do
        end do

        l=1
        do i=1, ncart 
         do j=(i+1), ncart 
          do k=1, ncart
          if (k .eq. j) then
           np(k,l) = q(k) + del(j)
          else if (k .eq. i) then
           np(k,l) = q(k) - del(i)
          else
           np(k,l) = q(k)
          end if
          end do
         l=l+1
         end do
        end do

        y=1
        do i=1, ncart
         write(file_id, '(i0)') y
         file_name = 'geo' // trim(adjustl(file_id)) // '.com'
         open(unit=5, file=trim(file_name), status='replace')

         write(5,*) trim(line1)
         write(5,*) trim(line2)
         write(5,*) " "
         write(5,*) "random"
         write(5,*) " "
         write(5,*) multcharge

         j=1
         l=1
         do while (j .le. ncart)
         write(5,*) atoms(l:l), (p(k,i), k=j, 2+j)
         j = j+3
         l = j - 2*l
         end do
         write(5,*) " "
         close(5)
         y=y+1
        end do

        
        do i=1, ncart
         write(file_id, '(i0)') y
         file_name = 'geo' // trim(adjustl(file_id)) // '.com'
         open(unit=5, file=trim(file_name), status='replace')

         write(5,*) trim(line1)
         write(5,*) trim(line2)
         write(5,*) " "
         write(5,*) "random"
         write(5,*) " "
         write(5,*) multcharge


         j=1
         l=1
         do while (j .le. ncart)
         write(5,*) atoms(l:l), (n(k,i), k=j, 2+j)
         j = j+3
         l = j - 2*l
         end do
         write(5,*) " "
         close(5)
         y=y+1
        end do



        do i=1, dime
         write(file_id, '(i0)') y
         file_name = 'geo' // trim(adjustl(file_id)) // '.com'
         open(unit=5, file=trim(file_name), status='replace')

         write(5,*) trim(line1)
         write(5,*) trim(line2)
         write(5,*) " "
         write(5,*) "random"
         write(5,*) " "
         write(5,*) multcharge


         j=1
         l=1
         do while (j .le. ncart)
         write(5,*) atoms(l:l), (pp(k,i), k=j, 2+j)
         j = j+3
         l = j - 2*l
         end do
         write(5,*) " "
         close(5)
         y=y+1
        end do

        do i=1, dime
         write(file_id, '(i0)') y
         file_name = 'geo' // trim(adjustl(file_id)) // '.com'
         open(unit=5, file=trim(file_name), status='replace')

         write(5,*) trim(line1)
         write(5,*) trim(line2)
         write(5,*) " "
         write(5,*) "random"
         write(5,*) " "
         write(5,*) multcharge


         j=1
         l=1
         do while (j .le. ncart)
         write(5,*) atoms(l:l), (nn(k,i), k=j, 2+j)
         j = j+3
         l = j - 2*l
         end do
         write(5,*) " "
         close(5)
         y=y+1
        end do


        do i=1, dime
         write(file_id, '(i0)') y
         file_name = 'geo' // trim(adjustl(file_id)) // '.com'
         open(unit=5, file=trim(file_name), status='replace')

         write(5,*) trim(line1)
         write(5,*) trim(line2)
         write(5,*) " "
         write(5,*) "random"
         write(5,*) " "
         write(5,*) multcharge

         j=1
         l=1
         do while (j .le. ncart)
         write(5,*) atoms(l:l), (pn(k,i), k=j, 2+j)
         j = j+3
         l = j - 2*l
         end do
         write(5,*) " "
         close(5)
         y=y+1
        end do

        do i=1, dime
         write(file_id, '(i0)') y
         file_name = 'geo' // trim(adjustl(file_id)) // '.com'
         open(unit=5, file=trim(file_name), status='replace')

         write(5,*) trim(line1)
         write(5,*) trim(line2)
         write(5,*) " "
         write(5,*) "random"
         write(5,*) " "
         write(5,*) multcharge

         j=1
         l=1
         do while (j .le. ncart)
         write(5,*) atoms(l:l), (np(k,i), k=j, 2+j)
         j = j+3
         l = j - 2*l
         end do
         write(5,*) " "
         close(5)
         y=y+1
        end do

        end program essiano
