        program hessian_diagonalizer
       
        use constants  

        implicit none 
        
        integer :: ncart
        
        integer :: i, j, k, col, h
        integer :: ncol, nrig

        real*8, allocatable :: hess(:,:) 
        real*8, allocatable :: inp(:,:)
        real*8, allocatable :: cnorm(:,:)
        real*8, allocatable :: ww(:)
        real*8, allocatable :: xm(:)
        !....................................................
        !Read the new variables:
        open (100,file='../parameters.dat', status="old")
        read(100,*) ncart
        close(100)
       
        allocate( hess(1:ncart,1:ncart) )
        allocate( cnorm(ncart,ncart) )
        allocate( ww(ncart) )
        allocate( xm(ncart) )
        hess(:,:) = 0.d0
        open (5,file='../mass_vec', status="old")
        do i=1, ncart
          read(5,*) xm(i)
        end do
        close(5)

        open (5,file='Hessian.out', status="old")
        k=1
        do i=1, ncart
          read(5,*) (hess(i,j), j=1, k)
          k=k+1
        end do 
        close(5)
        
        do i = 1, ncart
          do j = 1, ncart

              if ( i.le.j ) hess(i,j) = hess(i,j)
              if ( j.gt.i ) hess(i,j) = hess(j,i)

          enddo
        enddo
        
        !Mass weight the hessian
        do i = 1, ncart
          do j = 1, ncart
          hess( i, j ) = hess( i, j ) / dsqrt( xm(i)*xm(j) )
          enddo
        enddo

        call diagonalizer( ncart, hess, ww, cnorm )

        open (5,file='eigenvec.dat', status="replace")
        
        do i=1, ncart
50       format (*(d15.7))
         write(5,50) (cnorm(i,j), j=1, ncart)
        end do                
        close(5) 
        
        open (5,file='WW.dat', status="replace")
        do i=1, ncart
          write(5,*) ww(i)
        end do          
        close(5)

        endprogram hessian_diagonalizer
