        subroutine resonance( ter, fre, n, l, p, Fa, Fb, k, h )
        !Input: third der, freq, ter size, freq size, buffer size
        !Output: Matrices Fa and Fb with Ncol = 4. 
        !The first three point to the position, the fourth tells if
        !there is a resonance
        
        implicit none 

        integer :: n 
        real*8 :: ter(n,4) 
        real*8 :: fre(l)
        real*8 :: diff
        real*8 :: diffe(1:3)
        real*8 :: Fa(p,4) !Fermi type 1 resonance
        real*8 :: Fb(p,4) !Fermi type 2 resonance
        real*8 :: deltaA, deltaB
        integer :: i, j, k, l, p, v, h
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        Fa(:,:) = 0.d0
        Fb(:,:) = 0.d0
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !First check on freq: 200 of delta between them 
        h = 1
        k = 1
        do i=1, n 
        j = 1 
          !TYPE 1 check
          if ( (nint(ter(i,j)) .eq. nint(ter(i,j+1))) .and. &
          &(nint(ter(i,j+2)) .ne. nint(ter(i,j+1))) ) then
            diff=abs(2.d0*fre(nint(ter(i,j))) - fre(nint(ter(i,j+2))))
             if (diff < 200.d0) then
               deltaA = (ter(i,j+3)**4.d0)/(256.d0*(diff)**3)
               if (deltaA .ge. 1.d0) then
                Fa(k,1) = ter(i,j)
                Fa(k,2) = ter(i,j+1)
                Fa(k,3) = ter(i,j+2)
                Fa(k,4) = 1.d0
                k = k + 1
               end if   
             end if

          !TYPE 2 CHECK: 
          else if ( (ter(i,j) .ne. ter(i,j+1)) .and. (ter(i,j+1) .ne.&
                  & ter(i,j+2)) ) then

           diffe(1)=abs(fre(nint(ter(i,j)))+fre(nint(ter(i,j+1)))- &
           &fre(nint(ter(i,j+2))))
           diffe(2)=abs(fre(nint(ter(i,j+1)))+fre(nint(ter(i,j+2)))- &
           &fre(nint(ter(i,j))))
        
           diffe(3)=abs(fre(nint(ter(i,j)))+fre(nint(ter(i,j+2)))- &
           &fre(nint(ter(i,j+1))))
        
            do v=1, 3
              
             if (diffe(v) < 200.d0) then 
              deltaB = (ter(i,j+3)**4.d0)/(64.d0*(diffe(v))**3) 
              if (deltaB .ge. 1.d0) then
               if (v .eq. 1) then 
                Fb(h,1) = ter(i,j)
                Fb(h,2) = ter(i,j+1)
                Fb(h,3) = ter(i,j+2)
                Fb(h,4) = 1.d0 
                h = h + 1 
               else if (v .eq. 2) then 
                Fb(h,1) = ter(i,j+1)
                Fb(h,2) = ter(i,j+2)
                Fb(h,3) = ter(i,j)
                Fb(h,4) = 1.d0
                h = h + 1
               else if (v .eq. 3) then 
                Fb(h,1) = ter(i,j)  
                Fb(h,2) = ter(i,j+2)
                Fb(h,3) = ter(i,j+1)
                Fb(h,4) = 1.d0
                h = h + 1
               end if  
              end if
             end if
            end do
          end if  
        
        end do

        k=k-1
        h=h-1
   
        end subroutine 
