        subroutine vpt2r(ter, n, qua, m, fre, l, ra, a, rb, b, chi)
        implicit none 
        ! ter derivatives, dimension, fourth derivatives, dimension, freq,
        ! dim, type1 resonances, dim, type2 resonances, dim, position
        ! f.IMM, output X vector. 

        ! Input quantities: AU
        integer :: l, n, m, a, b
        real*8 :: ter(1:n,4)     
        real*8 :: qua(1:m,5)
        real*8 :: fre(1:l)
        real*8 :: ra(1:a,4) !Resonance vectors
        real*8 :: rb(1:b,4)
        ! Create the ter derivative tensor 
        real*8, allocatable :: ater(:,:,:) 
        ! Create the fourth derivative tensor
        real*8, allocatable :: aqua(:,:,:,:)
        ! Create the riso vector
        real*8, allocatable :: riso1(:,:,:) 
        real*8, allocatable :: riso2(:,:,:)
        real*8 :: sum1, sum2, sum3, sum4, sum5, sum6, sum7
        real*8 :: rs1, rs2, rs3, rs4, rs5, g1
        real*8 :: fim1 = 0
        real*8 :: fim2 = 0
        real*8 :: fim3 = 0
        real*8 :: fim4 = 0      
        
        integer :: i, j, k, h, p
                
        real*8 :: chi(1:l,1:l)
        
        chi(:,:) = 0.d0
        allocate(ater(l,l,l))
        ater(:,:,:) = 0.d0
        do i=1, n 
         ater(nint(ter(i,1)), nint(ter(i,2)), nint(ter(i,3)))&
         & = ter(i,4)
         ater(nint(ter(i,3)), nint(ter(i,2)), nint(ter(i,1)))&
         & = ter(i,4) 
         ater(nint(ter(i,2)), nint(ter(i,1)), nint(ter(i,3)))&
         & = ter(i,4)
         ater(nint(ter(i,1)), nint(ter(i,3)), nint(ter(i,2)))&
         & = ter(i,4)
         ater(nint(ter(i,3)), nint(ter(i,1)), nint(ter(i,2)))&
         & = ter(i,4)
         ater(nint(ter(i,2)), nint(ter(i,3)), nint(ter(i,1)))&
         & = ter(i,4)
        end do

        allocate(aqua(l,l,l,l))       
        aqua(:,:,:,:) = 0.d0  
        do i=1, m
         aqua(nint(qua(i,1)), nint(qua(i,2)), nint(qua(i,3)), &
         &nint(qua(i,4))) = qua(i,5)
         aqua(nint(qua(i,1)), nint(qua(i,2)), nint(qua(i,4)), &
         &nint(qua(i,3))) = qua(i,5)
         aqua(nint(qua(i,3)), nint(qua(i,4)), nint(qua(i,1)), &
         &nint(qua(i,2))) = qua(i,5)
        end do  
        allocate(riso1(l,l,l))
        allocate(riso2(l,l,l))
        riso1(:,:,:) = 0.d0
        riso2(:,:,:) = 0.d0 



        do i=1, a
         riso1(nint(ra(i,1)), nint(ra(i,2)), nint(ra(i,3))) = ra(i,4) 
        end do 

        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        do i=1, b
         riso2(nint(rb(i,1)), nint(rb(i,2)), nint(rb(i,3))) = rb(i,4)
         riso2(nint(rb(i,2)), nint(rb(i,1)), nint(rb(i,3))) = rb(i,4)
        end do
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        !X generation: diagonal matrix 

        do i=1, l
         do j=1, i
         sum1=0.d0
         sum2=0.d0
         sum3=0.d0
         sum4=0.d0
         sum5=0.d0
         sum6=0.d0
         sum7=0.d0
          if (i .eq. j) then
           !Check the res for sum2 generation
           do k=1, l
             if (riso1(i,i,k) .eq. 1) then ! Resonance check
              sum2=sum2+((ater(i,i,k)**2)/(fre(k)**2))*(2.d0+ &
              &(fre(k))/(2.d0*(2.d0*fre(i)+fre(k))))    
             else if (riso1(i,i,k) .eq. 0) then 
              sum2=sum2+((ater(i,i,k)**2)/(fre(k)**2))*(2.d0+ &
              &(fre(k))/(2.d0*(2.d0*fre(i)+fre(k)))- &
              &(fre(k))/(2.d0*(2.d0*fre(i)-fre(k))))       
             end if       
           end do
           chi(i,j) = (1.d0/(16.d0*(fre(i))**2))*(aqua(i,i,i,i) - sum2) 
        
          ! Off-diagonal ij
          else if (i .ne. j) then 
           do k=1, l 
             sum4=sum4+(ater(i,i,k)*ater(j,j,k))/(fre(k)**2)
             if (nint(riso2(i,j,k)) .eq. 1) then 
              rs1 = 0
             else 
              rs1 = 1.d0/(fre(i)+fre(j)-fre(k))
             end if 

             if (nint(riso2(i,k,j)) .eq. 1) then  
               rs2=0
             else if (nint(riso1(i,k,j)) .eq. 1) then
               rs2=0
             else 
               rs2 = 1.d0/(fre(i)-fre(j)+fre(k))
             end if 

             if (nint(riso2(j,k,i)) .eq. 1) then
              rs3=0
             else if (nint(riso1(j,k,i)) .eq. 1) then
              rs3=0
             else
              rs3 = 1.d0/(fre(i)-fre(j)-fre(k))
             end if

             sum5=sum5+((ater(i,j,k)**2)/(2.d0*fre(k)))*((1.d0/(fre(i)+&
             &fre(j)+fre(k))) - rs1 + rs2 - rs3)
             
           end do
          if ((i .eq. 2) .and. (j .eq. 1)) then
          end if 
          chi(i,j) = (1.d0/(4.d0*fre(i)*fre(j)))*(aqua(i,i,j,j)- &
          &sum4-sum5)  
          
          end if 
         end do 
        end do 

        sum1=0.d0
        sum2=0.d0
        sum3=0.d0
        rs1=0.d0
        rs2=0.d0
        rs3=0.d0

        do i=1, l
         sum1 = sum1 + aqua(i,i,i,i)/(64.d0*fre(i)**2) - &
         &(7.d0*ater(i,i,i)**2)/(576.d0*fre(i)**4)
        end do

        do i=1, l
         do j=1, l
          if (j .ne. i) then
           if (nint(riso1(i,i,j)) .eq. 1) then
        sum2 = sum2 + (3*ater(i,i,j)**2)/(64.d0*(fre(i)**2)*fre(j))*0.5d0*&
            &(-1.d0*(1.d0/(2.d0*fre(i)+fre(j))))
           else
         sum2 = sum2 + (3.d0*ater(i,i,j)**2)/(64.d0*(fre(i)**2)*&
         &fre(j))*0.5d0*&
            &(1.d0/(2.d0*fre(i)-fre(j)) - (1.d0/(2.d0*fre(i)+fre(j))))
           end if
          end if
         end do
        end do

        do i=1, l
         do j=i+1, l
          do k=j+1, l

            if (nint(riso2(j,k,i)) .eq. 1) then
             rs1=0
            else
             rs1=1.d0/(-fre(i)+fre(k)+fre(j))
            end if
            if (nint(riso2(k,i,j)) .eq. 1) then
             rs2=0
            else
             rs2=1.d0/(fre(k)+fre(i)-fre(j))
            end if
            if (nint(riso2(j,i,k)) .eq. 1) then
             rs3=0
            else
             rs3=1.d0/(fre(j)+fre(i)-fre(k))
            end if
           sum3 = sum3 + (ater(i,j,k)**2)/(4.d0*fre(k)*fre(j)*fre(i))*&
           &(1.d0/8.d0)*(1.d0/(fre(k)+fre(j)+fre(i)) - rs1 - rs2 - rs3)

          end do
         end do
        end do

        g1 = sum1 + sum2 - sum3

        write(*,*) g1*219474.63068d0





        end subroutine 
