        program corio

        use constants 

        implicit none
        !New definitions
        integer :: nf, nat, mok
         
        !-----------------
        !integer :: nf ! Freq number
        !-----------------

        real*8, allocatable, dimension(:,:) :: lx, ly, lz
        real*8, allocatable, dimension(:,:) :: corx, cory, corz
        real*8, allocatable, dimension(:) :: eigen, freq
        real*8, allocatable, dimension(:,:) :: Xcont
        real*8, dimension(3) :: B !ROTATIONAL CONSTANTS
        integer :: i, j, k, l, a
        real*8 :: X0_cont
        !-----------------
        
        open (100,file='../parameters.dat', status="old")
        read(100,*) mok
        read(100,*) nf
        read(100,*) mok
        read(100,*) nat
        close(100)
        
        !-----------------

        !nf = 3*nat - 6

        allocate(lx(nf,nat))
        allocate(ly(nf,nat))
        allocate(lz(nf,nat))
        allocate(corx(nf,nf))
        allocate(cory(nf,nf))
        allocate(corz(nf,nf))
        allocate(eigen(nf))
        allocate(freq(nf))
        allocate(Xcont(nf,nf))

        !-----------------
        corx(:,:)=0.d0
        cory(:,:)=0.d0
        corz(:,:)=0.d0
        !cortot(:,:,:)=0.d0
        Xcont(:,:)=0.d0
        !----------------------------------------------------
        ! From the Eckart frame calculation: 
        open(unit=5, file='../Rot_const', status='old')
        do i=1, 3
          read(5,*) B(i) !Rotational constants in GHz 
        end do
        close(5)
        !Conversion back to cm => may be avoided 
        do i=1, 3
          B(i) = B(i)*gtocm
        end do
        
        !----------------------------------------------------
        open(unit=5, file='../WW_vib.dat', status='old')
        do i=1, nf
        read(5,*) eigen(i)
        end do
        close(5)
        !----------------------------------------------------
        open(unit=5, file='Lx', status='old')
        do i=1, nat !Runs on the atoms 
        read(5,*) (lx(j,i), j=1, nf)
        end do
        close(5)
        open(unit=5, file='Ly', status='old')
        do i=1, nat
        read(5,*) (ly(j,i), j=1, nf)
        end do
        close(5)
        open(unit=5, file='Lz', status='old')
        do i=1, nat
        read(5,*) (lz(j,i), j=1, nf)
        end do
        close(5)

        
        do i=1, nf
        do j=1, nf
         do k=1, nat
         corx(i,j) = corx(i,j)+Ly(i,k)*Lz(j,k)-Lz(i,k)*Ly(j,k)
         cory(i,j) = cory(i,j)+Lz(i,k)*Lx(j,k)-Lx(i,k)*Lz(j,k)
         corz(i,j) = corz(i,j)+Lx(i,k)*Ly(j,k)-Ly(i,k)*Lx(j,k)
         end do
        end do
        end do


        !---------------------------------------------
        !Conversion of the eigenvalues in frequencies in CM^-1
        !Modes are printed in ascending order 
        do i=1, nf
         freq(i) = dsqrt(abs(eigen(i)))*autoc           
        end do 

        open(unit=5, file='freq_vib.dat', status='replace')
         do i=1, nf
         write(5,*) freq(i)
         end do
        close(5)
        !--------------------------------------------------

        !Calculation of the total Coriolis contribution to X  
        !Note that later, if you are working with the Gaussian software, 
        !the freq vector must be ordered accordingly to its printing. 

        do k=1, nf
          do l=1, nf
          if (eigen(l) .lt. 0.d0) then
              Xcont(k,l) = (freq(k)/freq(l) - &
              & freq(l)/freq(k))*B(1)*(corx(k,l))**2+(freq(k)/freq(l)- &
              & freq(l)/freq(k))*B(2)*(cory(k,l))**2+(freq(k)/freq(l)- &
              & freq(l)/freq(k))*B(3)*(corz(k,l))**2
          else if (eigen(k) .lt. 0.d0) then 
           Xcont(k,l) = (-freq(k)/freq(l) + &
           &freq(l)/freq(k))*B(1)*(corx(k,l))**2+(-freq(k)/freq(l)+&
           &freq(l)/freq(k))*B(2)*(cory(k,l))**2+(-freq(k)/freq(l)+&
           &freq(l)/freq(k))*B(3)*(corz(k,l))**2
          else 
            Xcont(k,l) = (freq(k)/freq(l) + &
            &freq(l)/freq(k))*B(1)*(corx(k,l))**2+(freq(k)/freq(l)+&
            &freq(l)/freq(k))*B(2)*(cory(k,l))**2+(freq(k)/freq(l)+&
            &freq(l)/freq(k))*B(3)*(corz(k,l))**2
          end if 
          end do
        end do

        X0_cont=0.d0
        X0_cont=X0_cont+0.25d0*(B(1)+B(2)+B(3))
        do k=1, nf
          do l=1, nf
       X0_cont=X0_cont+0.25d0*(B(1)*(corx(k,l))**2+B(2)*(corx(k,l))**2+&
              &B(3)*(corx(k,l))**2)
          end do
        end do

        write(*,*) X0_cont

        open(unit=6, file='Corio_X.dat', status='replace')
        do i=1, nf
        write(6,*) Xcont(i,:)
        end do
        close(6)
        


        !---------------------------------------------


        endprogram corio

