        program eckartMain

        use constants 
        use insub         

        implicit none 
        
        !New variables:
        integer :: ncart, nat, mok        
        
        integer i, j, k
        character (len=10), allocatable :: symb(:)  
        real(8), allocatable :: x(:)
        real(8), allocatable :: xm(:)
        real(8), allocatable :: amass(:)
        real(8) :: Xcm(1:3)
        real(8) :: nvec(1:3,1:3), idia(1:3) 
        real(8) :: waste, mtot 

        !Read new variables:
        open (100,file='../parameters.dat', status="old")
        read(100,*) ncart
        read(100,*) mok
        read(100,*) mok
        read(100,*) nat
        close(100)


        open(100,file='input_eckart', status="old")
        open(101,file='../mass_vec', status="old")
        allocate(x(ncart))
        allocate(xm(ncart))
        allocate(amass(nat))        
        allocate(symb(nat))
        
        do i=1, nat 
          read(100,*) symb(i), x(3*i-2:3*i) 
        end do 
        do i=1, ncart
          read(101,*) xm(i)
        end do         
        rewind(101) 
        do i=1, nat 
         do j=1, 2
          read(101,*) waste 
         end do 
          read(101,*) amass(i)
        end do 
        
        close(100)
        close(101)

        mtot = sum(amass)
        call centermass(nat,x,xm,mtot,Xcm)
        ! Shift geometry to CM frame
        do i = 1, nat
          x( 1+(i-1)*3 : 3+(i-1)*3 ) = x( 1+(i-1)*3 : 3+(i-1)*3 ) - &
          &Xcm(1:3)
        enddo
        ! Rotate to Principal Axes Frame
        call paframe(xm,x,nvec,idia)
        
        open(102,file='output_eckart', status="replace")
        ! Print the rotated geometry of the molecule  
        do i = 1, nat
          write(102,*) symb(i), x( 1+(i-1)*3 : 3+(i-1)*3 )
        enddo
        close(102)

        open(102,file='Rot_const', status="replace")
        do i=1, 3
         write(102,*) (1.d0/idia(i))*(1.d0/(0.00000001d0)**2)*&
         &(1.d0/mele)*cmtog*&
         &planck*(1.d0/(8.d0*pi**2))*(1.d0/sol)
        end do 
        close(102)

        end program eckartMain
